-- name: THPS1 - Warehouse (Arena Add-on)
-- description: THPS1's Warehouse Level, ported to Mario 64! Map Rip and Arena edit done by Buckley Tim. ARENA MUST BE ON FOR THIS TO WORK.

local audioToPlay = audio_stream_load("64_Superman.ogg")

-- use fixed collisions
gLevelValues.fixCollisionBugs = 1

-- register level
LEVEL_ARENA_WAREHOUSE = 105
level_register('level_warehouseA_entry', COURSE_NONE, "Warehouse", 'warehouse', 28000, 0x28, 0x28, 0x28)
local level_arena_warehouse = smlua_level_util_get_info_from_short_name('warehouse')
level_arena_warehouse.levelNum = LEVEL_ARENA_WAREHOUSE

-- make sure we don't add the level twice
local addedLevels = false

local function on_level_init()
    -- make sure we don't add the level twice
    if addedLevels then return end
    addedLevels = true

    -- make sure Arena was loaded
    if not _G.Arena then
        djui_popup_create("Error: the Arena gamemode wasn't loaded!", 2)
        return
    end

    -- add the level to arena
    _G.Arena.add_level(LEVEL_ARENA_WAREHOUSE, 'Warehouse')
end

-----
--audio stuff
-----

function on_warp()

    --debug that gives me level id on warp when enabled
    --djui_popup_create(gNetworkPlayers[0].currLevelNum .. "", 2)

    if gNetworkPlayers[0].currLevelNum == 105 then
        stop_background_music(get_current_background_music())
        audio_stream_stop(audioToPlay)

        audio_stream_destroy(audioToPlay)
        audioToPlay = audio_stream_load("64_Superman.ogg")
        audio_stream_set_looping(audioToPlay, true)
        audio_stream_play(audioToPlay, true, 1)
    else
        audio_stream_stop(audioToPlay)

    end
end

-- disable cap music
-- this code taken from the arena dx mod
function music()
    local np = gNetworkPlayers[0]
    if np.currLevelNum == 105 then
        stop_cap_music()
    end
end

hook_event(HOOK_ON_LEVEL_INIT, on_level_init)

hook_event(HOOK_UPDATE, music)
hook_event(HOOK_ON_WARP, on_warp)
